/**
 * License Agreement.
 *
 * Rich Faces - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */
package org.richfaces.model;

import java.util.Iterator;

import javax.faces.component.UIComponent;
import javax.faces.component.UIComponentBase;


/**
 * That is intended for internal use
 * 
 * @author Nick Belaevski mailto:nbelaevski@exadel.com created 25.07.2007
 * 
 */
public abstract class StackingTreeModelProvider extends UIComponentBase {

	public abstract Object getNodes();
	public abstract void setNodes(Object nodes);

	public Object getData() {
		return getNodes();
	}
	
	protected abstract StackingTreeModel createStackingTreeModel();

	public StackingTreeModel getStackingModel() {
		StackingTreeModel stackingTreeModel = createStackingTreeModel();
		if (getChildCount() > 0) {
			Iterator children = getChildren().iterator();
			while (children.hasNext()) {
				UIComponent component = (UIComponent) children.next();
				if (component instanceof StackingTreeModelProvider) {
					StackingTreeModelProvider provider = (StackingTreeModelProvider) component;
					
					stackingTreeModel.addStackingModel(provider.getStackingModel());
				}
			}
		}
		
		return stackingTreeModel;
	}
}
